django/class_based_views/project/basic_app/urls.py
from django.contrib import admin
from django.urls import path, re_path
from basic_app import views
# from project import basic_app
app_name = 'basic_app'

urlpatterns = [
    path('school_list/', views.SchoolListView.as_view(), name='school_list'),
    path('index/', views.IndexView.as_view(), name='index'),
    path('school_list/<str:pk>/', views.SchoolDetailView.as_view(), name='school_detail'),
    path('create/', views.SchoolCreateView.as_view(), name='school_create'),
    path('update/<str:pk>/', views.SchoolUpdateView.as_view(), name='school_update'),
    path('delete/<str:pk>/', views.SchoolDeleteView.as_view(), name='school_delete'),
]

django/class_based_views/project/project/urls.py
from django.contrib import admin
from django.urls import path
from django.urls.conf import include
from basic_app import views

urlpatterns = [
    path('admin/', admin.site.urls),
    path('basic_app/', include('basic_app.urls', namespace='basic_app')),
]

django/class_based_views/project/basic_app/models.py
from os import name
from django.db import models
from django.urls import reverse


# Create your models here.
class School(models.Model):
    name = models.CharField(max_length=50)
    principal = models.CharField(max_length=50)
    location = models.CharField(max_length=123)

    def __str__(self):
        return self.name
    
    def get_absolute_url(self):
        return reverse("basic_app:school_detail", kwargs={"pk": self.pk})
    
    

class Student(models.Model):
    name = models.CharField(max_length=123)
    age = models.PositiveIntegerField()
    school = models.ForeignKey(School, related_name="students", on_delete=True)

    def __str__(self):
        return self.name

django/class_based_views/project/basic_app/views.py
from django.shortcuts import render
from django.views.generic import (TemplateView, View, ListView, DetailView, CreateView, DeleteView,
                                UpdateView)  
from basic_app import models
from django.urls import reverse_lazy

class IndexView(TemplateView):
    template_name = 'index.html'

class SchoolListView(ListView):
    context_object_name = 'school_list'
    model = models.School

class SchoolDetailView(DetailView):
    context_object_name = 'school_detail'
    model = models.School
    template_name = 'basic_app/school_detail.html'

class SchoolCreateView(CreateView):
    fields = ('name', 'principal', 'location')
    model = models.School

class SchoolUpdateView(UpdateView):
    fields = ('name', 'principal', 'location')
    model = models.School

class SchoolDeleteView(DeleteView):
    model = models.School
    success_url = reverse_lazy('basic_app:school_list')

django/class_based_views/project/basic_app/templates/basic_app/school_confirm_delete.html
{%extends 'base.html'%}
{%load staticfiles%}
{%block body_block%}
<div class="jumbotron">
    <h1>Delete {{school.name}}?</h1>
    <form method="POST">
        {%csrf_token%}
        <input type="submit" class="btn btn-danger" value="Delete">
        <a href="{%url 'basic_app:school_detail' pk=school.pk%}">Cancel</a>
    </form>
</div>
{%endblock%}

django/class_based_views/project/basic_app/templates/basic_app/school_detail.html
<!DOCTYPE html>
{%extends "base.html"%}
{%load staticfiles%}
{% block body_block %}
<div class="jumbotron">
    <h1>Welcome to a list of all schools</h1>
    <p>Name: {{school_detail.name}}</p>
    <p>Principal: {{school_detail.principal}}</p>
    <p>Location: {{school_detail.location}}</p>
</div>

{%for student in school_detail.students.all%}
    <p>{{student.name}} who is {{student.age}} years old</p>
{%endfor%}


<div class="container">
    <p><a href="{%url 'basic_app:school_update' pk=school_detail.pk%}" class="btn btn-warning">Update</a></p>
</div>
{% endblock %}

django/class_based_views/project/basic_app/templates/basic_app/school_form.html
{%extends "base.html"%}
{%load staticfiles%}
{% block body_block %}
<h1>
    {%if not form.instance.pk%}
    Create School
    {%else%}
    Update School
    {%endif%}
</h1>
<form action="" method="POST">
    {%csrf_token%}
    {{form.as_p}}
    <input type="submit" class="btn btn-primary" name="" id="">
</form>

{%endblock%}

django/class_based_views/project/basic_app/templates/basic_app/school_list.html
<!DOCTYPE html>
{%extends "base.html"%}
{%load staticfiles%}
{% block body_block %}
<div class="jumbotron">
    <h1>Welcome to a list of all schools</h1>
    <ol>
        {%for school in school_list%}
            <h2><li><a href="{{school.id}}">{{school.name}}</a></li></h2>
        {%endfor%}
    </ol>
</div>
{% endblock %}

django/class_based_views/project/templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <!-- CSS only -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    <title>Document</title>
</head>
<body>
    <nav class="navbar navbar-expand-lg navbar-light bg-dark">
        <div class="container">
            <ul class="nav navbar-nav">
                <li><a class="navbar-brand" href="#">Brand</a></li>
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'admin:index' %}">Admin</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'basic_app:school_list' %}">List</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'basic_app:index' %}">Index</a>
                </li>         
            </ul>
        </div>
    </nav>
    <div class="container">
        {% block body_block %}
        {% endblock %}
    </div>
</body>
</html>

django/class_based_views/project/templates/index.html
<!DOCTYPE html>
{%extends "base.html"%}
{%load staticfiles%}
{% block body_block %}
    <h1>Index</h1>
    <h2>Injected {{injectme}}</h2>
{% endblock %}